<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Zoku :: Console</title>
</head>
<body>
<h1>Zoku Console</h1>
<br />

<?php

$zs_site_root = dirname(__FILE__)."/"; // server root
$namespace = "zokuws";

/**
 * @var string Separator for couple (key => value)
 */
$zs_separator_vars = "__VARSEPARATOR__";

/**
 * @var string Separator between varname and value in a couple (key => value)
 */
$zs_separator_value = "__VALUESEPARATOR__";

require_once $zs_site_root."config/config.php";
// Unsetting critical vars ...
unset($zs_db_user);
unset($zs_db_pass);
unset($zs_db_host);
unset($zs_db_name);
require_once $zs_site_root."nusoap/lib/nusoap.php";
require_once $zs_site_root."includes/functions/common.php";

$server = $zs_server_url."server.php";
if(isset($_POST['server']))
{
	$server = $_POST['server'];
}

$username = "";
if(isset($_POST['username']))
{
	$username = $_POST['username'];
}

$password = "";
if(isset($_POST['password']))
{
	$password = $_POST['password'];
}

$client = new nusoap_client($server);

$commands = array();
$result = $client->call('commandList');
if (!$client->getError())
{
	$commands = $result;
}
else
{
	echo $client->getError();
	echo "\n\n";
	echo "REQUEST :\n";
	echo htmlspecialchars($client->request, ENT_QUOTES)."\n\n";
	echo "RESPONSE :\n";
	echo htmlspecialchars($client->response, ENT_QUOTES)."\n\n";
}

if(isset($_POST['function']) && isset($_POST['parameters']) && isset($_POST['username']) && isset($_POST['password']))
{
	if(!empty($username) && $username != "")
	{
		$hash_password = $password;
		if(isset($_POST['md5']) && $_POST['md5'] == "yes")
		{
			$hash_password = md5($hash_password);
		}
		$session_header = "<session xmlns=\"urn:$namespace\"><username>$username</username><password>$hash_password</password></session>";
		$client->setHeaders($session_header);
	}
	
	$parameters = array();
	
	if($_POST['type'] != "none")
	{
		if(!empty($_POST['parameters']) && $_POST['parameters'] != "")
		{
			$params_rows = explode("\n", $_POST['parameters']);
			foreach ($params_rows as $key => $param)
			{
				$param_row = explode("=", $param);
				$var = trim($param_row[0]);
				$value = trim($param_row[1]);
				$parameters[$var] = $value;
			}
		}
		if($_POST['type'] == "array")
		{
			//$parameters = array('row' => zs_serialize_array($parameters));
			$parameters = array('row' => new soapval('row', 'Row', $parameters, false, 'urn:ZokuRow'));
		}
	}
	$result = $client->call($_POST['function'], $parameters);
	echo '<textarea id="result" name="result" cols="100" rows="3" readonly="readonly">';
	if(!$client->getError())
	{
		print_r($result);
		echo "\n\n";
		echo "REQUEST :\n";
		echo htmlspecialchars($client->request, ENT_QUOTES)."\n\n";
		echo "RESPONSE :\n";
		echo htmlspecialchars($client->response, ENT_QUOTES)."\n\n";
	}
	else
	{
		echo "ERROR : ";
		print_r($client->getError());
		echo "\n\n";
		echo "REQUEST :\n";
		echo htmlspecialchars($client->request, ENT_QUOTES)."\n\n";
		echo "RESPONSE :\n";
		echo htmlspecialchars($client->response, ENT_QUOTES)."\n\n";
		//echo "DEBUG :\n";
		//echo htmlspecialchars($client->debug_str, ENT_QUOTES);
	}
	echo "</textarea><br /><br />";
}

?>
<form id="zoku_console" method="post" action="">
	<table width="100%" border="0">
		<tr>
			<td width="350" align="right">Zoku Server :</td>
			<td><input id="server" name="server" type="text" size="45" maxlength="1024" value="<?php echo $server; ?>" /></td>
		</tr>
		<tr>
			<td width="350" align="right">Session.Username :</td>
			<td><input id="username" name="username" type="text" size="45" maxlength="1024" value="<?php echo $username; ?>" /></td>
		</tr>
		<tr>
			<td width="350" align="right">Session.Password :</td>
			<td><input id="password" name="password" type="password" size="45" maxlength="1024" value="<?php echo $password; ?>" /> (<input id="md5" name="md5" value="yes" type="checkbox" checked="checked" /> MD5 hashing)</td>
		</tr>
		<tr>
			<td width="350" align="right">Function :</td>
			<td><select id="function" name="function">
				<option value="" selected="selected"></option>
				<?php 
					foreach ($commands as $key => $value)
					{
						echo '<option value="'.$value.'">'.$value.'</option>';
					}
				?>
			</select></td>
		</tr>
		<tr>
			<td width="350" align="right">Parameters type :</td>
			<td><select id="type" name="type">
				<option value="none">None</option>
				<option value="list" selected="selected">List</option>
				<option value="array">Array</option>
			</select></td>
		</tr>
		<tr>
			<td width="350" align="right">Parameters :</td>
			<td><textarea id="parameters" name="parameters" cols="34" rows="10" >var1 = value1
var2 = value2</textarea></td>
		</tr>
		<tr>
			<td width="350" align="right"></td>
			<td><input id="send" name="send" type="submit" value="Send" /></td>
		</tr>
	</table>
</form>
</body>
</html>