<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_Card extends ZS_User
{
	public $key = -1;
	public $first_name = "";
	public $last_name = "";
	public $birthdate = "";
	public $gender = "";
	public $phone  = "";
	public $address  = "";
	public $city  = "";
	public $zipcode  = "";
	public $country  = "";
	public $type = "";
	public $photo  = "";
	public $website  = "";
	public $url  = "";
	public $group_id = -1;
	public $other = "";
	
	
	function __construct($row = "")
	{
		parent::__construct($row);
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	
	public function createFromArray($array)
	{
		parent::createFromArray($array);
		if (isset($array['id']))		{ $this->id = $array['id']; };
		if (isset($array['key']))		{ $this->key = $array['key']; };
		if (isset($array['username']))	{ $this->username = $array['username']; };
		if (isset($array['password']))	{ $this->password = $array['password']; };
		if (isset($array['first_name'])){ $this->first_name = $array['first_name']; };
		if (isset($array['last_name']))	{ $this->last_name = $array['last_name']; };
		if (isset($array['birthdate']))	{ $this->birthdate = $array['birthdate']; };
		if (isset($array['gender']))	{ $this->gender = $array['gender']; };
		if (isset($array['email']))		{ $this->email = $array['email']; };
		if (isset($array['address']))	{ $this->address = $array['address']; };
		if (isset($array['city']))		{ $this->city = $array['city']; };
		if (isset($array['zipcode']))	{ $this->zipcode = $array['zipcode']; };
		if (isset($array['country']))	{ $this->country = $array['country']; };
		if (isset($array['type']))		{ $this->type = $array['type']; };
		if (isset($array['group_id']))	{ $this->group_id = $array['group_id']; };
		if (isset($array['photo']))		{ $this->photo = $array['photo']; };
		if (isset($array['website']))	{ $this->website = $array['website']; };
		if (isset($array['url']))		{ $this->url = $array['url']; };
		if (isset($array['other']))		{ $this->other = $array['other']; };
		if (isset($array['admin']))		{ $this->admin = $array['admin']; };
		if (isset($array['phone']))		{ $this->phone = $array['phone']; };
		return true;
	}
	
	
	public function delete()
	{
		return $this->getDBLink()->query("DELETE FROM `".$this->getDBPrefix()."_card` WHERE `id` = '$this->id'");
	}
	
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function selectByKey($key)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `key` = '$key'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function selectByIdAndKey($id, $key)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `id` = '$id' AND `key` = '$key'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function createInDB()
	{
		$this->generateKey();
		$this->hashPassword();
		if ($result = $this->getDBLink()->query("INSERT INTO `".$this->getDBPrefix()."_card` 
		(`key`, `username`, `password`, `email`, `first_name`, `last_name`, `birthdate`, `gender`, `phone`, `address`, `city`, `zipcode`, `country`, `photo`, `website`, `url`, `type`, `group_id`, `other`, `admin`, `last_ip`, `last_dns`, `last_date`, `create_date`) 
		VALUES 
		('$this->key', '$this->username', '$this->password', '$this->email',
		'$this->first_name', '$this->last_name', '$this->birthdate', '$this->gender', '$this->phone',
		'$this->address', '$this->city', '$this->zipcode', '$this->country',
		'$this->photo', '$this->website', '$this->url', '$this->type',
		'0', '$this->other', '0', '".$_SERVER['REMOTE_ADDR']."', '".gethostbyaddr($_SERVER['REMOTE_ADDR'])."', '0', '".time()."')"))
		{
			$this->id = $this->getDBLink()->lastId();
			$keystoric = new ZS_KeyStoric(array("key" => $this->key, "card_id" => $this->id));
			$keystoric->createInDB();
		}
		return $result;
	}
	
	public function updateIntoDB()
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_card` SET 
		`key` = '$this->key',
		`username` = '$this->username',
		`password` = '$this->password',
		`email` = '$this->email',
		`first_name` = '$this->first_name',
		`last_name` = '$this->last_name',
		`birthdate` = '$this->birthdate',
		`gender` = '$this->gender',
		`phone` = '$this->phone',
		`address` = '$this->address',
		`city` = '$this->city',
		`zipcode` = '$this->zipcode',
		`country` = '$this->country',
		`type` = '$this->type',
		`photo` = '$this->photo',
		`website` = '$this->website',
		`url` = '$this->url',
		`other` = '$this->other' WHERE `id` = '$this->id'");
	}
	
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	

	public function generateCard()
	{
		global $zs_server_url;
		return ($zs_server_url."images/card.php?id=".$this->id."&amp;hash=".$this->generateHash());
	}
	
	public function selectVars($vars)
	{
		// TODO
		// faut retourner les variables PUBLIC si le mec est pas connect, et PRIVATE s'il l'est
		// donc une fois le systme de session oprationnel, on fait cette mthode ...
	}
	
	public function getPublicVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PUBLIC') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		$result = $this->removeCriticalVars($result);
		return $result;
	}
	
	public function getPrivateVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PRIVATE') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		$result = $this->removeCriticalVars($result);
		return $result;
	}
	
	public function checkConsistency()
	{
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$i = 0;
		foreach ($required as $key => $value)
		{
			if (isset($vars[$value]) && trim($vars[$value]) != "" && $vars[$value] != -1)
			{
				$i++;
			}
		}
		if ($i == count($required))
		{
			return true;
		}
		return false;
	}
	
	public function getRequiredVarNames()
	{
		global $zs_classes_vars_info;
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'REQUIRED') === FALSE))
			{
				$result[] = $key;
			}
		}
		return $result;
	}	
	
	public function getUsedVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'USED') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		$result = $this->removeCriticalVars($result);
		return $result;
	}
	
	public function generateHash()
	{
		$vars = $this->getVars();
		$hash = "";
		foreach ($vars as $key => $value)
		{
			$hash .= "[$key|$value]";
		}
		return md5($hash);
	}
	
	public function getMissingVars()
	{
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$missing = array();
		foreach ($required as $key => $value)
		{
			if (!(isset($vars[$value]) && $vars[$value] != "" && $vars[$value] != -1 && !empty($vars[$value])))
			{
				$missing[] = $value;
			}
		}
		return $missing;
	}
	
	public function generateKey()
	{
		global $zs_server_id;
		$validKey = false;
		while (!$validKey)
		{
			$key = base_convert(substr(sha1(time().$this->generateHash().rand(0,1000000)), 0, 13), 16, 36);
			$key = substr($key, 0, 10);
			while (strlen($key) < 10)
			{
				$key = "0".$key;
			}
			$key = base_convert($zs_server_id, 10, 36).$key;
			while (strlen($key) < 12)
			{
				$key = "0".$key;
			}
			$key = strtoupper($key);
			$key .= zs_generateKeyCheckSum($key);
			
			$keystoric = new ZS_KeyStoric();
			if ($keystoric->ifNotExists($key))
			{
				$validKey = true;
			}
		}
		$this->key = $key;
		return $this->key;
	}
	
	public function getGroupId()
	{
		return $this->group_id;
	}
	
	public function setGroupId($group)
	{
		$this->group_id = $group;
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_card` SET `group_id` = '$this->group_id' WHERE `id` = '$this->id'");
	}
	
	public function searchByName($search)
	{
		$sql = "SELECT `id`, `username`, `first_name`, `last_name` FROM `".$this->getDBPrefix()."_card` WHERE `username` LIKE '%$search%' OR `firt_name` LIKE '%$search%' `last_name` LIKE '%$search%'";
		if ($result = $this->getDBLink()->query($sql))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$array[] = $row['id']."#".$row['username']." : ".$row['first_name']." ".$row['last_name'];
			}
			return $array;
		}
		return false;
	}
	
	public function searchByNameInGroup0($search)
	{
		$sql = "SELECT `id`, `username`, `first_name`, `last_name`, `group_id` FROM `".$this->getDBPrefix()."_card` WHERE `group_id` = '0' AND `username` LIKE '%$search%' OR `first_name` LIKE '%$search%' OR `last_name` LIKE '%$search%'";
		if ($result = $this->getDBLink()->query($sql))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$array[] = $row['id']."#".$row['username']." : ".$row['first_name']." ".$row['last_name'];
			}
			return $array;
		}
		return false;
	}
	
	public function searchByNameInAgroup($search, $group_id)
	{
		$sql = "SELECT `id`, `username`, `first_name`, `last_name`, `group_id` FROM `".$this->getDBPrefix()."_card` WHERE `group_id` = '$group_id' AND `username` LIKE '%$search%' OR `first_name` LIKE '%$search%' OR `last_name` LIKE '%$search%'";
		if ($result = $this->getDBLink()->query($sql))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$array[] = $row['id']."#".$row['username']." : ".$row['first_name']." ".$row['last_name'];
			}
			return $array;
		}
		return false;
	}
	
	private function removeCriticalVars($array = array())
	{
		$criticalVars = array("password");
		foreach ($criticalVars as $key => $value)
		{
			if (isset($array[$value]))
			{
				unset($array[$value]);
			}
		}
		return $array;
	}
	
	public function getLastSince($date)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `create_date` >= '$date' ORDER BY `create_date` DESC"))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$card = new ZS_Card($row);
				$array[] = $card->getPublicVars();
			}
			return $array;
		}
		return false;
	}
}

?>