<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_EventMember extends ZS_Base
{
	public $id;
	public $event_id;
	public $card_id;
	public $controller_id;
	public $date;
	
	
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	
	public function createFromArray($array)
	{
		if (isset($array['id']))			{ $this->id = $array['event']; };
		if (isset($array['event_id']))		{ $this->event_id = $array['event_id']; };
		if (isset($array['card_id']))		{ $this->card_id = $array['card_id']; };
		if (isset($array['controller_id']))	{ $this->controller_id = $array['controller_id']; };
		if (isset($array['date']))			{ $this->admin = $array['date']; };
		return true;
	}
	
	
	public function delete()
	{
		return $this->getDBLink()->query("DELETE FROM `".$this->getDBPrefix()."_eventmember` WHERE `id` = '$this->id'");
	}
	
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_eventmember` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	
	public function createInDB()
	{
		$result = $this->getDBLink()->query("INSERT INTO `".$this->getDBPrefix()."_eventmember` 
		(`event_id`, `card_id`, `controller_id`, `date`) 
		VALUES 
		('$this->event_id', '$this->card_id', '$this->controller_id', '".time()."')");
		if ($result)
		{
			$this->id = $this->getDBLink()->lastId();
		}
		return $result;
	}
	
	
	public function updateIntoDB()
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_eventmember` SET 		
		`event_id` = '$this->event_id', 
		`card_id` = '$this->card_id', 
		`controller_id` = '$this->controller_id',
		`date` = '$this->date' WHERE `id` = '$this->id'");
	}
	
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	
	public function selectVars($vars)
	{
		// TODO
		// faut retourner les variables PUBLIC si le mec est pas connect, et PRIVATE s'il l'est
		// donc une fois le systme de session oprationnel, on fait cette mthode ...
	}
	
	public function getPublicVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PUBLIC') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getPrivateVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PRIVATE') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function checkConsistency()
	{
		// TODO
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$i = 0;
		foreach ($required as $key => $value)
		{
			if (isset($vars[$value]) && trim($vars[$value]) != "" && $vars[$value] != -1)
			{
				$i++;
			}
		}
		if ($i == count($required))
		{
			return true;
		}
		return false;
	}
	
	public function getRequiredVarNames()
	{
		global $zs_classes_vars_info;
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'REQUIRED') === FALSE))
			{
				$result[] = $key;
			}
		}
		return $result;
	}	
	
	public function getUsedVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'USED') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getMissingVars()
	{
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$missing = array();
		foreach ($required as $key => $value)
		{
			if (!(isset($vars[$value]) && $vars[$value] != "" && $vars[$value] != -1 && !empty($vars[$value])))
			{
				$missing[] = $value;
			}
		}
		return $missing;
	}
	
	public function getEventGroupId()
	{
		if ($result = $this->getDBLink()->query("SELECT group_id FROM $this->{prefix}_event WHERE `id` = '$this->event_id'"))
		{
			if($event = $this->getDBLink()->fetch($result))
			{
				return $event;
			}
		}
	}
	
	public function getMemberGroupId()
	{
		if ($result = $this->getDBLink()->query("SELECT group_id FROM $this->{prefix}_card WHERE `id` = '$this->card_id'"))
		{
			if($group = $this->getDBLink()->fetch($result))
			{
				return $group;
			}
		}
	}
}

?>