<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_Group extends ZS_Base
{
	public $id = -1;
	public $name = "";
	public $email = "";
	public $phone = "";
	public $address = "";
	public $city = "";
	public $zipcode = "";
	public $country ="";
	public $logo = "";
	public $url = "";
	public $website = "";
	public $supergroup_id = -1;
	public $owner_id = -1;	
	public $type = "";
	public $acronym = "";
	public $create_date = 0;

		
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}

	
	public function createFromArray($array)
	{
		if (isset($array['id']))			{ $this->id = $array['id']; };
		if (isset($array['name']))			{ $this->name = $array['name']; };
		if (isset($array['address']))		{ $this->address = $array['address']; };
		if (isset($array['email']))			{ $this->email = $array['email']; };
		if (isset($array['phone']))			{ $this->phone = $array['phone']; };
		if (isset($array['website']))		{ $this->website = $array['website']; };
		if (isset($array['supergroup_id']))	{ $this->supergroup_id = $array['supergroup_id']; };
		if (isset($array['city']))			{ $this->city = $array['city']; };
		if (isset($array['zipcode']))		{ $this->zipcode = $array['zipcode']; };
		if (isset($array['country']))		{ $this->country = $array['country']; };
		if (isset($array['logo']))			{ $this->logo = $array['logo']; };
		if (isset($array['url']))			{ $this->url = $array['url']; };
		if (isset($array['owner_id']))		{ $this->owner_id = $array['owner_id']; };
		if (isset($array['type']))			{ $this->type = $array['type']; };
		if (isset($array['acronym']))		{ $this->acronym = $array['acronym']; };
		if (isset($array['create_date']))	{ $this->create_date = $array['create_date']; };
		return true;
	}
	
	
	public function delete()
	{
		return $this->getDBLink()->query("DELETE FROM `".$this->getDBPrefix()."_group` WHERE `id` = '$this->id'");
	}
	
	
	public function createInDB()
	{
		$result = $this->getDBLink()->query("INSERT INTO `".$this->getDBPrefix()."_group` 
		(`name`, `acronym`, `email`, `phone`, `address`, `city`, `zipcode`, `country`,
		 `logo`, `url`, `website`, `type`, `supergroup_id`, `owner_id`, `create_date`) 
		VALUES 
		('$this->name', '$this->acronym', '$this->email', '$this->phone', '$this->address', '$this->city', '$this->zipcode', '$this->country',
		'$this->logo', '$this->url', '$this->website', '$this->type', '0', '$this->owner_id', '".time()."')");
		if ($result)
		{
			$this->id = $this->getDBLink()->lastId();
		}
		return $result;
	}
	
	
	public function updateIntoDB()
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_group` SET 		
		`name` = '$this->name', 
		`email` = '$this->email', 
		`phone` = '$this->phone',
		`address` = '$this->address', 
		`city` = '$this->city', 
		`zipcode` = '$this->zipcode', 
		`country` = '$this->country',
		`logo` = '$this->logo', 
		`url` = '$this->url', 
		`website` = '$this->website',
		`type` = '$this->type',
		`acronym` = '$this->acronym',
		`supergroup_id` = '$this->supergroup_id',
		`owner_id` = '$this->owner_id' WHERE `id` = '$this->id'");
	}
	
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	
	
	public function count()
	{
		if ($rown = $this->getDBLink()->query("SELECT COUNT(`id`) FROM `".$this->getDBPrefix()."_card` WHERE `group_id` = '$this->id'"))
		{
			$result = $this->getDBLink()->result($rown);
			return $result;
		} 
		return -1;	
	}
	
	
	// should NEVER be used (out of memory ...)
	public function getAll()
	{ 
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `group_id` = '$this->id'")) 
		{ 
			$cards = array(); 
			$i = 0; 
			while ($row = $this->getDBLink()->fetch($result)) 
			{ 
				$cards[i] = new ZS_User($row); 
				$i++; 
			} 
			return $cards; 
		} 
		return false; 
	}	
	
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_group` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function selectByName($name)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_group` WHERE `name` = '$name'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function selectVars($vars)
	{
		// TODO
		// faut retourner les variables PUBLIC si le mec est pas connect, et PRIVATE s'il l'est
		// donc une fois le systme de session oprationnel, on fait cette mthode ...
	}
	
	public function getPublicVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PUBLIC') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getPrivateVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PRIVATE') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function checkConsistency()
	{
		// TODO
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$i = 0;
		foreach ($required as $key => $value)
		{
			if (isset($vars[$value]) && trim($vars[$value]) != "" && $vars[$value] != -1)
			{
				$i++;
			}
		}
		if ($i == count($required))
		{
			return true;
		}
		return false;
	}
	
	public function getRequiredVarNames()
	{
		global $zs_classes_vars_info;
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'REQUIRED') === FALSE))
			{
				$result[] = $key;
			}
		}
		return $result;
	}		
	
	public function getUsedVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'USED') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getMembers()
	{
		if ($sql = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `group_id` = '$this->id'"))
		{
			$members = array();
			while ($row = $this->getDBLink()->fetch($sql))
			{
				$card = new ZS_Card($row);
				$members[] = $card->getPublicVars();
			}
			return $members;
		}
		return false;
	}
	
	public function getMissingVars()
	{
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$missing = array();
		foreach ($required as $key => $value)
		{
			if (!(isset($vars[$value]) && $vars[$value] != "" && $vars[$value] != -1 && !empty($vars[$value])))
			{
				$missing[] = $value;
			}
		}
		return $missing;
	}
	
	public function searchByName($search)
	{
		$sql = "SELECT id, name FROM ".$this->getDBPrefix()."_group WHERE `name` LIKE '%$search%' OR `acronym` LIKE '%$search%'";
		if ($result = $this->getDBLink()->query($sql))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$array[] = $row['name'];
			}
			return $array;
		}
		return false;
	}
	
	public function getEvents()
	{
		$events = array();
		if ($sql = $this->getDBLink()->query("SELECT `id`, `name` FROM `".$this->getDBPrefix()."_event` WHERE `group_id` = '$this->id'"))
		{
			while ($row = $this->getDBLink()->fetch($sql))
			{
				$events[] = $row;
			}
		}
		return $events;
	}
	
	public function getLastSince($date)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_group` WHERE `create_date` >= '$date' ORDER BY `create_date` DESC"))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$group = new ZS_Group($row);
				$array[] = $group->getPublicVars();
			}
			return $array;
		}
		return false;
	}
}

?>