<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

// 
// Date : 27/03/2010
// Rvision : 27/03/2010 - v0.000
// Auteurs : WALTHER Jrmy (golflima@ftad.fr) & MOLE Bruno (revy@ftad.fr)
// Fichier : Functions.php
// Description : liste des fonctions courrament utilises par le site

// Fonction empchant les injections SQL
function zs_noSQL($sql)
{
	$sql = preg_replace("/(from|select|insert|delete|where|drop table|show tables|update|into|alter table|#|\*|--|\\\\)/i","",$sql);
	$sql = trim($sql);
	$sql = strip_tags($sql);
	$sql = addslashes($sql);
	return $sql;
}

function zs_Echap($sql)
{
	$sql = htmlspecialchars($sql);
	return $sql;
}

function zs_strToUpper($chaine)
{
	$chaine= strtoupper($chaine);
	//$chaine= utf8_decode($chaine);
	//$chaine= trim($chaine);
	$chaine = strtr($chaine, "", "ƌ");
	//$chaine= utf8_encode($chaine);
	return $chaine;
}

function zs_getMicroTime()
{
	list($usec, $sec) = explode(" ",microtime()); 
	return ((float)$usec + (float)$sec); 
}

function zs_checkEmail($email)
{
	return preg_match('#^(([a-z0-9!\#$%&\\\'*+/=?^_`{|}~-]+\.?)*[a-z0-9!\#$%&\\\'*+/=?^_`{|}~-]+)@(([a-z0-9-_]+\.?)*[a-z0-9-_]+)\.[a-z]{2,}$#i',str_replace('&amp;','&',$email));
}

function zs_checkDate($date)
{
	return preg_match('#^([0-2][0-9]|3[0,1])[/](0[0-9]|1[0-2])[/]([1-2][0-9]{3})$#',$date);
}

function zs_checkUsername($name)
{
	return preg_match('#^[a-zA-Z_][a-zA-Z_0-9]*$#',$name);
}

/**
* Serialize an array.
*
* @param	array	$array	The array to serialize
* @return	string	The serialized array
* @access	public
*/
function zs_serialize_array($array = array())
{
	global $zs_separator_vars;
	global $zs_separator_value;
	
	$result = "";
	foreach ($array as $key => $value)
	{
		$result .= $key.$zs_separator_value.$value.$zs_separator_vars;
	}
	return $result;
}

/**
* Unserialize an array.
*
* @param	string	$ser	The serialized array
* @return	array	The unserialized array
* @access	public
*/
function zs_unserialize_array($ser = "")
{
	global $zs_separator_vars;
	global $zs_separator_value;
	
	$result = array();
	$vars = explode($zs_separator_vars, $ser);
	foreach ($vars as $key => $couple)
	{
		$line = explode($zs_separator_value, $couple);
		if (trim($line[0]) != "")
		{
			$var = trim($line[0]);
			$value = trim($line[1]);
			$result[$var] = $value;
		}
	}
	return $result;
}

function zs_adminArrayToInt($array = array(	"super"			=> false,
											"admin"			=> false,
											"group"			=> false,
											"card"			=> false,
											"event"			=> false,
											"eventmember"	=> false,
											"unused1"		=> false,
											"unused0"		=> false))
{
	$int = 0;
	if (isset($array["super"]) && $array["super"])
	{
		$int += 128;
	}
	if (isset($array["admin"]) && $array["admin"])
	{
		$int += 64;
	}
	if (isset($array["group"]) && $array["group"])
	{
		$int += 32;
	}
	if (isset($array["card"]) && $array["card"])
	{
		$int += 16;
	}
	if (isset($array["event"]) && $array["event"])
	{
		$int += 8;
	}
	if (isset($array["eventmember"]) && $array["eventmember"])
	{
		$int += 4;
	}
	if (isset($array["unused1"]) && $array["unused1"])
	{
		$int += 2;
	}
	if (isset($array["unused0"]) && $array["unused0"])
	{
		$int += 1;
	}
	return $int;
}

function zs_adminIntToArray($int = 0)
{
	$array = array(	"super"			=> false,
					"admin"			=> false,
					"group"			=> false,
					"card"			=> false,
					"event"			=> false,
					"eventmember"	=> false,
					"unused1"		=> false,
					"unused0"		=> false);
	$keys = array("super", "admin", "group", "card", "event", "eventmember", "unused1", "unused0");
	$i = 0;
	$bin = 128;
	$old = $int;
	for ($i = 0; $i < 8; $i++)
	{
		$int = ($old = $int) % $bin;
		$array[$keys[$i]] = $old != $int;
		$bin /= 2;
	}
	return $array;
}

function zs_generateKeyCheckSum($key = "")
{
	$allowedChars = array(	"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", 
							"C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", 
							"O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
	if (strlen($key) == 12)
	{
		$first = 0;
		$second = 0;
		for ($i = 0; $i < 12; $i += 2)
		{
			$first += array_search(substr($key, $i, 1), $allowedChars, false);
		}
		for ($i = 1; $i < 12; $i += 2)
		{
			$second += array_search(substr($key, $i, 1), $allowedChars, false);
		}
		$first = $first % 36;
		$second = $second % 36;
		return $allowedChars[$first].$allowedChars[$second];
	}
	return false;
}

/*function zs_base16to32($b16)
{
	$b16 = strtoupper($b16);
	while (strlen($b16) % 3 != 0)
	{
		$b16 = "0".$b16;
	}
	$b32_values = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C",
						"D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
						"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
	$b16_array = array();
	$b16_length = strlen($b16) - 1;
	$i = 0;
	for ($i = $b16_length; $i > -1 ; $i--)
	{
		$b16_array[$b16_length - $i] = array_search(substr($b16, $i, 1), $b32_values, false);
	}
	$b32 = "";
	$b32_cl = $b16_length / 3;
	for ($i = 0; $i < $b32_cl; $i++)
	{
		$value = $b16_array[$i] * 256 + $b16_array[$i + 1] * 16 + $b16_array[$i + 2];
		$b32 .= $b32_values[(int) ($value / 32)] . $b32_values[$value % 32]; // u're doin'it right
	}
	return $b32;
}

function zs_base10to2($b10)
{
	return (string) decbin($b10);
}

function zs_base2to6($b2)
{
	return (string) base_convert($b2, 2, 6);
}

function zs_base10to6($b10)
{
	return (string) base_convert($b10, 10, 6);
}

function zs_base6to36($b6)
{
	$b6 = strtoupper($b6);
	while (strlen($b6) % 2 != 0)
	{
		$b6 = "0".$b6;
	}
	echo "b6 = $b6<br />\n";
	$b36_values = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C",
						"D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
						"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
	$b6_array = array();
	$b6_length = strlen($b6) - 1;
	$i = 0;
	for ($i = $b6_length; $i > -1 ; $i--)
	{
		$b6_array[$b6_length - $i] = array_search(substr($b6, $i, 1), $b36_values, false);
	}
	$b36 = "";
	$b36_length = (int) (strlen($b6) / 2);
	for ($i = 0; $i < $b36_length; $i++)
	{
		$value = $b6_array[$i] * 6 + $b6_array[$i + 1];
		$b36 = $b36_values[$value] . $b36; 
	}
	return $b36;
}

function zs_base10to36($b10)
{
	return zs_base6to36(zs_base10to6($b10));
}

function zs_md5($txt)
{
	if (CRYPT_MD5 != 1)
	{
		die('ERROR : This server does not support MD5 hashing');
	}
	$values = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D",
					"E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R",
					"S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f",
					"g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t",
					"u", "v", "w", "x", "y", "z");
	$generate = true;
	while ($generate)
	{
		$md5c = crypt(time(), $salt = '$1$'.rand(0,999999).'$');
		$md5 = substr($md5c, strlen($salt), strlen($md5c) - strlen($salt));
		$md5l = strlen($md5);
		$c = 0;
		for ($i = 0; $i < $md5l; $i++)
		{
			if (in_array(substr($md5, $i, 1), $values))
			{
				$c++;
			}
		}
		if ($i == $c)
		{
			$generate = false;
		}
	}
	return $md5;
}*/
?>