<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

require_once $zs_site_root."system/includes.php";

//start time
$zs_starttime = zs_getMicroTime();

// loading NuSOAP lib ...
require_once $zs_site_root."nusoap/lib/nusoap.php";

$zs_dblink = new ZS_MySQLLink();
if(isset($zs_mysql_ressource))
{
	$zs_dblink->setConnection($zs_mysql_ressource);
}
else
{
	$zs_dblink->Connect($zs_db_host, $zs_db_user, $zs_db_pass, $zs_db_name);
}

// Unsetting critical vars ...
unset($zs_db_user);
unset($zs_db_pass);
unset($zs_db_host);
unset($zs_db_name);

$zs_server_postdata = "";
if (isset($_GET['soap']))
{
	$zs_server_postdata = stripslashes(htmlspecialchars_decode(urldecode($_GET['soap'])));
	$_SERVER['REQUEST_METHOD'] = "POST";
	$HTTP_SERVER_VARS['REQUEST_METHOD'] = "POST";
	unset($_SERVER['QUERY_STRING']);
	unset($HTTP_SERVER_VARS['QUERY_STRING']);
	$_SERVER['REQUEST_URI'] = $_SERVER['PHP_SELF'];
	function getallheaders()
	{
		return array(	'content-type'	=>	"text/xml; charset=ISO-8859-1");
	}
}
else
{
	// Getting raw post data
	$zs_server_postdata = file_get_contents("php://input");
}

// Creating SOAP server (using NuSOAP)
$zs_server = new nusoap_server();

$namespace = "zokuws";

// Registring server functions
//$zs_server->register('createUser'); // deprecated
$zs_server->register('createCard');
$zs_server->register('createGroup');
$zs_server->register('createSuperGroup');
$zs_server->register('deleteCard');
$zs_server->register('deleteGroup');
$zs_server->register('deleteSuperGroup');
$zs_server->register('deleteEvent');
$zs_server->register('deleteEventMember');
$zs_server->register('showCard');
$zs_server->register('createEvent');
$zs_server->register('createEventMember');
$zs_server->register('getEventMembers');
$zs_server->register('getGroupMembers');
$zs_server->register('getCardRequiredVars');
$zs_server->register('getGroupRequiredVars');
$zs_server->register('getEventRequiredVars');
$zs_server->register('getEventMemberRequiredVars');
$zs_server->register('getCardPublicVars');
$zs_server->register('getGroupPublicVars');
$zs_server->register('getEventPublicVars');
$zs_server->register('getEventMemberPublicVars');
$zs_server->register('getCardPrivateVars');
$zs_server->register('getGroupPrivateVars');
$zs_server->register('getEventPrivateVars');
$zs_server->register('getEventMemberPrivateVars');
$zs_server->register('getCardAllVars');
$zs_server->register('getGroupAllVars');
$zs_server->register('getEventAllVars');
$zs_server->register('getEventMemberAllVars');
$zs_server->register('updateCard');
$zs_server->register('updateGroup');
$zs_server->register('updateEvent');
$zs_server->register('updateEventMember');
//$zs_server->register('headerAuthentify');
$zs_server->register(	'debugHeaders', 
						array(),      						// input parameters
    					array('return' => 'xsd:string'),    // output parameters
    					"uri:$namespace",                   // namespace
    					"uri:$namespace/debugHeaders",      // SOAPAction
   						'rpc',                              // style
    					'encoded');
$zs_server->register(	'debugLogin',
						array(),      						// input parameters
    					array('return' => 'xsd:string'),    // output parameters
    					"uri:$namespace",                   // namespace
    					"uri:$namespace/debugLogin",      // SOAPAction
   						'rpc',                              // style
    					'encoded');
$zs_server->register(	'commandList',
						array(),      						// input parameters
    					array('return' => 'xsd:string'),    // output parameters
    					"uri:$namespace",                   // namespace
    					"uri:$namespace/commandList",       // SOAPAction
   						'rpc',                              // style
    					'encoded');
$zs_server->register('testRow');
$zs_server->register('regenerateCardKey');
$zs_server->register('getGroupByName');
$zs_server->register('getMemberByName');
$zs_server->register('getMemberByNameInGroup0');
$zs_server->register('getMemberByNameInMyGroup');
$zs_server->register('addCardToGroup');
$zs_server->register('removeCardFromGroup');
$zs_server->register('getGroupIdByName');
$zs_server->register('getGroupNameById');
$zs_server->register('verifyCardByKey');
$zs_server->register('getEventsOfMyGroup');
$zs_server->register('registerCardIntoEvent');
$zs_server->register('setAdmin');
$zs_server->register('getAdmin');
$zs_server->register('getLastCardsSince');
$zs_server->register('getLastGroupsSince');
$zs_server->register('getLastEventsSince');

// log requests
if ($zs_enable_log_requests)
{
	if ($zs_log_file = fopen($zs_site_root."logs/requests_".date("Y-m-d").".log", "a"))
	{
		fwrite($zs_log_file, "Request from [".$_SERVER['REMOTE_ADDR']." / ".gethostbyaddr($_SERVER['REMOTE_ADDR'])."] on [".date("l, F jS, Y")."] at [".date("H")."h".date("i")."m".date("s")."s] :\n".$zs_server_postdata."\n");
		fclose($zs_log_file);
	}
}

// Parse headers to create a session
require $zs_site_root."system/parser_headers.php";
if ($zs_user_username != "" && $zs_user_password != "")
{
	headerAuthentify($zs_user_username, $zs_user_password);
}

// Setting input/output for the SOAP server
$zs_server->service($zs_server_postdata);

// close database connection
$zs_dblink->Close();

// log requests
if ($zs_enable_log_requests)
{
	if ($zs_log_file = fopen($zs_site_root."logs/requests_".date("Y-m-d").".log", "a"))
	{
		//fwrite($zs_log_file, $zs_server->response."\n");
		fwrite($zs_log_file, "Executed in [".(zs_getMicroTime() - $zs_starttime)."s], with [".$zs_dblink->getCount()."] SQL requests in [".$zs_dblink->getTime()."s], with [".$zs_object_cnt."] objects created.\n\n");
		fclose($zs_log_file);
	}
}

// log server debug
if ($zs_enable_log_debug)
{
	if ($zs_log_file = fopen($zs_site_root."logs/debug_".date("Y-m-d").".log", "a"))
	{
		fwrite($zs_log_file, "Request from [".$_SERVER['REMOTE_ADDR']." / ".gethostbyaddr($_SERVER['REMOTE_ADDR'])."] on [".date("l, F jS, Y")."] at [".date("H")."h".date("i")."m".date("s")."s] :\n".$zs_server_postdata."\n");
		foreach($_SERVER as $key => $value)
		{
			fwrite($zs_log_file, '$_SERVER['.$key.'] = '.$value."\n");
		}
		foreach($_POST as $key => $value)
		{
			fwrite($zs_log_file, '$_POST['.$key.'] = '.$value."\n");
		}
		foreach($_GET as $key => $value)
		{
			fwrite($zs_log_file, '$_GET['.$key.'] = '.$value."\n");
		}
		fwrite($zs_log_file, "\n");
		fclose($zs_log_file);
	}
}

// log nusoap debug
if ($zs_enable_log_nusoap)
{
	if ($zs_log_file = fopen($zs_site_root."logs/nusoap-debug_".date("Y-m-d").".log", "a"))
	{
		fwrite($zs_log_file, $zs_server->getDebug());
		fwrite($zs_log_file, "\n\n");
		fclose($zs_log_file);
	}
}

?>